unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ImgList, Menus, ShellApi, ShlObj,
  ComServ, ComObj, ActiveX, ExtCtrls;

type
  TForm1 = class(TForm)
    ImageList1: TImageList;
    ListBox1: TListBox;
    ListBox2: TListBox;
    PopupMenu1: TPopupMenu;
    m1: TMenuItem;
    m2: TMenuItem;
    m3: TMenuItem;
    Timer2: TTimer;
    Timer1: TTimer;
    Panel1: TPanel;
    ListView: TListView;
    Memo1: TMemo;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListViewClick(Sender: TObject);
    procedure ListViewCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure ListViewKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer2Timer(Sender: TObject);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    //
    procedure LV_WMNotify(var Msg: TWMNotify); message WM_NOTIFY;
    procedure Timer1Timer(Sender: TObject);
    procedure m3Click(Sender: TObject);
    procedure m2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  protected 
    { Protected declarations }
    procedure Panel_WndProc(var Message: TMessage);
    procedure Form_WndProc(var Message: TMessage);
  end;

var
  Form1: TForm1;
  pu_menu: boolean;
  but_push: boolean=false;
  i_ndex, i_min, i_max: integer;
  FPanelWndProc, FFormWndProc: TWndMethod;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
 i,j: integer;
 nitem: TListItem;
begin
 FPanelWndProc:=Panel1.WindowProc;
 FFormWndProc:=WindowProc; //   ListView   
 Panel1.WindowProc:=Panel_WndProc;
 WindowProc:=Form_WndProc;//   ListView   
 //
 ListView.Clear;
 ListView.DoubleBuffered:= true;
 // 
 j:=0;
 for i:=0 to 15 do
  begin
   nitem:=ListView.Items.Add();
   nitem.Data:=Pointer(clwhite);
   j:=j+5;
   nitem.Caption:='qwerty_'+IntToStr(j);
   nitem.SubItems.Add(IntToStr(i));
   nitem.SubItems.Add('-');
   nitem.SubItems.Add('xXx');
  end;
 //
 ListBox1.Items.Clear;
 for i:=0 to 9 do
  ListBox1.Items.Add(IntToStr(i+1));
end;

procedure TForm1.FormResize(Sender: TObject);
begin
{ Memo1.Left:=30;
 Memo1.Width:=ListView.Columns.Items[0].Width
                   +ListView.Columns.Items[1].Width-22;  }
end;

procedure TForm1.ListViewClick(Sender: TObject);
{
var
 i: integer;
 xy: TPoint;
 RectItem: TRect;
}
begin
 {
 if ListView.Selected<>nil
 then
  begin
   Memo1.Visible:=true;
   //
   RectItem:=ListView.Items.Item[ListView.ItemIndex].DisplayRect(drBounds);
   Memo1.Top:=RectItem.Top+10;
   Memo1.Text:=ListView.Items.Item[ListView.ItemIndex].Caption
     +'.'
     +ListView.Items.Item[ListView.ItemIndex].SubItems.Strings[0];
   //
   ListView.Items.Item[ListView.ItemIndex].Focused:=false;
   ListView.Items.Item[ListView.ItemIndex].Selected:=false;
   //
   Memo1.SetFocus;
   Memo1.SelectAll;
  end;
 }
 i_ndex:=ListView.ItemIndex;
end;

procedure TForm1.ListViewCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
var
 d: Pointer;
 i,x,x1,offs: integer;
 RectItem,ItemRect: TRect;
begin
 if Item=nil
 then Exit;
 //
 if ListView.ViewStyle=TViewStyle(vsReport)
 then
  begin
   DefaultDraw:=false;
   RectItem:=Item.DisplayRect(drBounds);
   //
   //  Item    
   if cdsSelected in State
   then
    begin
     Sender.Canvas.Font.Style:=Sender.Canvas.Font.Style+[fsBold];
     //
     d:=ListView.Items.Item[ListView.ItemIndex].Data;
     i:=Integer(d);
     if i=clYellow
     then Sender.Canvas.Font.Color:=clYellow
     else Sender.Canvas.Font.Color:=clNavy;
     //
     Sender.Canvas.Brush.Color:=clAqua;
     Sender.Canvas.FillRect(RectItem); //   
     //
     if ListView.Items.Item[Item.Index].SubItems[1]='<DIR>'
     then ImageList1.Draw(Sender.Canvas,RectItem.Left,RectItem.Top,0)
     else ImageList1.Draw(Sender.Canvas,RectItem.Left,RectItem.Top,2);
     //
     if ListView.Canvas.TextWidth(Item.Caption)>=ListView.Columns[0].Width-(RectItem.Left+18)
     then
      begin
       Sender.Canvas.TextOut(RectItem.Left+18,RectItem.Top+1,Item.Caption);
       Sender.Canvas.TextOut(ListView.Columns[0].Width-ListView.Canvas.TextWidth('..'),RectItem.Top+1,'..');
      end
     else Sender.Canvas.TextOut(RectItem.Left+18,RectItem.Top+1,Item.Caption);
     //
     if ListView.Canvas.TextWidth(Item.SubItems[0])>=ListView.Columns[1].Width
     then
      begin
       Sender.Canvas.TextOut(ListView.Columns[0].Width,RectItem.Top+1,Item.SubItems.Strings[0]);
       Sender.Canvas.TextOut(ListView.Columns[0].Width+ListView.Columns[1].Width-ListView.Canvas.TextWidth('..'),RectItem.Top+1,'..');
      end
     else Sender.Canvas.TextOut(ListView.Columns[0].Width+ListView.Columns[1].Width,RectItem.Top+1,Item.SubItems.Strings[1]);
     //
     if ListView.Canvas.TextWidth(Item.SubItems[1])>=ListView.Columns[2].Width
     then
      begin
       Sender.Canvas.TextOut(ListView.Columns[0].Width+ListView.Columns[1].Width,RectItem.Top+1,Item.SubItems.Strings[1]);
       Sender.Canvas.TextOut(ListView.Columns[0].Width+ListView.Columns[1].Width+ListView.Columns[2].Width-ListView.Canvas.TextWidth('..'),RectItem.Top+1,'..');
      end
     else Sender.Canvas.TextOut(ListView.Columns[0].Width+ListView.Columns[1].Width,RectItem.Top+1,Item.SubItems.Strings[1]);
     //  SubItem'  
     ItemRect:=Item.DisplayRect(drSelectBounds);
     x:=ListView.Columns.Items[0].Width;
     for i:=1 to ListView.Columns.Count-1 do // subitems   
      begin
       x1:=x+ListView.Columns[i].Width; // x1 -  ""
       case ListView.Columns[i].Alignment of
         taCenter: offs:=((x1+x) shr 1)-(ListView.Canvas.TextWidth(Item.SubItems[i-1]) shr 1);
         taRightJustify: offs:=x1-6-ListView.Canvas.TextWidth(Item.SubItems[i-1]);
         else offs:=x+4;
       end;
       with ListView.Canvas do
        TextRect(Rect(x, ItemRect.Top, x1, ItemRect.Bottom), offs, ItemRect.Top+2, Item.SubItems[i-1]);
       x:=x+ListView.Columns[i].Width; //  ""
      end;
    end
   else /////////////////////////////////////////////////////////
    begin
     Sender.Canvas.Font.Style:=Sender.Canvas.Font.Style+[fsBold];
     //
     Sender.Canvas.Pen.Style:=psSolid;
     //
     Sender.Canvas.Font.Color:=TColor(Item.Data);
     Sender.Canvas.FillRect(RectItem);
     //
     if ListView.Items.Item[Item.Index].SubItems[1]='<DIR>'
     then ImageList1.Draw(Sender.Canvas,RectItem.Left,RectItem.Top,0)
     else ImageList1.Draw(Sender.Canvas,RectItem.Left,RectItem.Top,2);
     //
     if ListView.Canvas.TextWidth(Item.Caption)>=ListView.Columns[0].Width-(RectItem.Left+18)
     then
      begin
       Sender.Canvas.TextOut(RectItem.Left+18,RectItem.Top+1,Item.Caption);
       Sender.Canvas.TextOut(ListView.Columns[0].Width-ListView.Canvas.TextWidth('..'),RectItem.Top+1,'..');
      end
     else Sender.Canvas.TextOut(RectItem.Left+18,RectItem.Top+1,Item.Caption);
     //
     if ListView.Canvas.TextWidth(Item.SubItems[0])>=ListView.Columns[1].Width
     then
      begin
       Sender.Canvas.TextOut(ListView.Columns[0].Width,RectItem.Top+1,Item.SubItems.Strings[0]);
       Sender.Canvas.TextOut(ListView.Columns[0].Width+ListView.Columns[1].Width-ListView.Canvas.TextWidth('..'),RectItem.Top+1,'..');
      end
     else Sender.Canvas.TextOut(ListView.Columns[0].Width+ListView.Columns[1].Width,RectItem.Top+1,Item.SubItems.Strings[1]);
     //
     if ListView.Canvas.TextWidth(Item.SubItems[1])>=ListView.Columns[2].Width
     then
      begin
       Sender.Canvas.TextOut(ListView.Columns[0].Width+ListView.Columns[1].Width,RectItem.Top+1,Item.SubItems.Strings[1]);
       Sender.Canvas.TextOut(ListView.Columns[0].Width+ListView.Columns[1].Width+ListView.Columns[2].Width-ListView.Canvas.TextWidth('..'),RectItem.Top+1,'..');
      end
     else Sender.Canvas.TextOut(ListView.Columns[0].Width+ListView.Columns[1].Width,RectItem.Top+1,Item.SubItems.Strings[1]);
     //  SubItem'  
     ItemRect:=Item.DisplayRect(drSelectBounds);
     x:=ListView.Columns.Items[0].Width;
     for i:=1 to ListView.Columns.Count-1 do // subitems   
      begin
       x1:=x+ListView.Columns[i].Width; // x1 -  ""
       case ListView.Columns[i].Alignment of
         taCenter: offs:=((x1+x) shr 1)-(ListView.Canvas.TextWidth(Item.SubItems[i-1]) shr 1);
         taRightJustify: offs:=x1-6-ListView.Canvas.TextWidth(Item.SubItems[i-1]);
         else offs:=x+4;
       end;
       with ListView.Canvas do
        TextRect(Rect(x, ItemRect.Top, x1, ItemRect.Bottom), offs, ItemRect.Top+2, Item.SubItems[i-1]);
       x:=x+ListView.Columns[i].Width; //  ""
      end;
    end;
   end
 else DefaultDraw:=true; //    vsReport
end;

procedure TForm1.ListViewKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
 d: Pointer;
 i: integer;
 defdraw: boolean;
begin
 case Key of
   VK_INSERT:
       begin
        // ListView.Items.Item[0].Data
        d:=ListView.Items.Item[ListView.ItemIndex].Data;
        i:=Integer(d);
        if i=clYellow
        then ListView.Items.Item[ListView.ItemIndex].Data:=Pointer(clWhite)
        else ListView.Items.Item[ListView.ItemIndex].Data:=Pointer(clYellow);
        //    
        if ListView.Selected.Index<>ListView.Items.Count-1
        then
         begin
          defdraw:=false;
          //      ,     
          ListView.OnCustomDrawItem(ListView,ListView.Items.Item[ListView.ItemIndex],[cdsSelected],defdraw);
          ListView.ItemIndex:=ListView.Selected.Index+1;
         end
        else
         begin
          defdraw:=false;
          //      ,     
          ListView.OnCustomDrawItem(ListView,ListView.Items.Item[ListView.ItemIndex],[cdsSelected],defdraw);
          ListView.ItemIndex:=ListView.Selected.Index;
         end;
       end;
 end;
end;

procedure TForm1.ListViewMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
 d: Pointer;
 i: integer;
 Item: TListItem;
 defdraw: boolean;
begin
 defdraw:=false;
 //
 if pu_menu=true
 then
  begin
   pu_menu:=false;
   Exit;
  end;
 //
 if ssRight in Shift
 then
  begin
   Item:=ListView.GetItemAt(x, y);
   d:=Item.Data;
   i:=Integer(d);
   if i=clYellow
   then ListView.Items.Item[ListView.ItemIndex].Data:=Pointer(clWhite)
   else ListView.Items.Item[ListView.ItemIndex].Data:=Pointer(clYellow);
   //      ,     
   ListView.OnCustomDrawItem(ListView,Item,[cdsSelected],defdraw);
  end;
end;

//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////

procedure TForm1.Timer2Timer(Sender: TObject);
begin
 Timer2.Enabled:=false;
 if but_push=true
 then PopupMenu1.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
 but_push:=false;
end;

procedure TForm1.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Timer2.Enabled:=false;
 but_push:=false;
end;

/////////////////////////////////////////////////////////////

procedure TForm1.Panel_WndProc(var Message: TMessage);
begin
 if Assigned(FPanelWndProc)
 then FPanelWndProc(Message);
 if Message.Msg=WM_NOTIFY
 then LV_WMNotify(TWMNotify(Message));
end;

procedure TForm1.Form_WndProc(var Message: TMessage);
begin
 if Assigned(FFormWndProc)
 then FFormWndProc(Message);
 if Message.Msg=WM_NOTIFY
 then LV_WMNotify(TWMNotify(Message));
end;

procedure TForm1.LV_WMNotify(var Msg: TWMNotify);
begin
 if (Msg.NMHdr.idFrom = ListView.Handle)
 then ListBox2.Items.Insert(0,IntToStr(Msg.NMHdr.code));
 //
 if (Msg.NMHdr.idFrom = ListView.Handle)
 then
  begin
   if (Msg.NMHdr.code = -2) //    
    or (Msg.NMHdr.code = -5) //    
    or (Msg.NMHdr.code = -3) //     
    or (Msg.NMHdr.code = -6) //     
    // or (Msg.NMHdr.code = -12) //      
   then Timer1.Enabled:=false;
   //
   if (Msg.NMHdr.code = -16) //      
   then
    begin
     Timer1.Interval:=800;
     Timer1.Enabled:=true;
    end;
  end;
 //
 inherited;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 if Assigned(FPanelWndProc)
 then Panel1.WindowProc:=FPanelWndProc;
 if Assigned(FFormWndProc)
 then WindowProc:=FFormWndProc;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
 d: Pointer;
 i: integer;
 Item: TListItem;
 defdraw: boolean;
begin
 Timer1.Enabled:=false;
 //
 m1.Caption:='"'+ListView.Selected.Caption+'"';
 //
 if GetAsyncKeyState(VK_RBUTTON)<>0 // VK_LBUTTON, VK_MBUTTON
 then PopupMenu1.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
 //
 pu_menu:=true;
end;

procedure TForm1.m3Click(Sender: TObject);
var
 i: integer;
 defdraw: boolean;
begin
 defdraw:=false;
 for i:=0 to ListView.Items.Count-1 do
  begin
   ListView.Items.Item[i].Data:=Pointer(clYellow);
   //      ,     
   ListView.OnCustomDrawItem(ListView,ListView.Items.Item[ListView.ItemIndex],[cdsSelected],defdraw);
  end;
 ListView.Invalidate; //   ListView
end;

procedure TForm1.m2Click(Sender: TObject);
var
 d: Pointer;
 i,j: integer;
 defdraw: boolean;
begin
 defdraw:=false;
 for i:=0 to ListView.Items.Count-1 do
  begin
   d:=ListView.Items.Item[i].Data;
   j:=Integer(d);
   if j=clYellow
   then ListView.Items.Item[i].Data:=Pointer(clWhite)
   else ListView.Items.Item[i].Data:=Pointer(clYellow);   
   //      ,     
   ListView.OnCustomDrawItem(ListView,ListView.Items.Item[ListView.ItemIndex],[cdsSelected],defdraw);
  end;
 ListView.Invalidate; //   ListView
end;

end.

